package ru.svem.ircbot.plugins;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.util.Iterator;
import java.util.Map;
import java.util.NavigableMap;
import java.util.Random;
import java.util.Set;
import java.util.TreeMap;
import java.util.Vector;


public class GorodaPlugin extends ru.svem.ircbot.MegaIrcBotPlugin{
	
	
	public static final int OK = 0;
	public static final int CITY_IN_USE = -1;
	public static final int CITY_NOT_EXIST = -2;
	public static final int CITY_NOT_VALID = -3;
	public static final int GAME_OVER = -4;
	
	boolean gorodaIsRun = false;
	boolean gorodaRegistrationOpen = false;
	String gorodaMain = "";
	Vector<String> gorodaPlayers;
	int gorodaCurUser = 0;
//	GorodaPlugin gorodaGame;
	long gorodaLastAction = 0;
	boolean gorodaIsWarning = false;
	String gorodaChannel = "#goroda_game";
	final long GORODA_MAX_REG_TIME = 300000;
	final long GORODA_MAX_ANS_TIME = 120000;
	
	public void message(String channel,String author,String msg){
		if(msg.length()>6 && msg.substring(0, 7).equalsIgnoreCase(ru.svem.ircbot.MegaIrcBot.OPPREFIX+"города")){
			goroda(channel,author,msg.substring(7));
		}
		if(gorodaIsRun && author.equalsIgnoreCase(gorodaPlayers.get(gorodaCurUser))){
			goroda(channel, author, " "+msg);
		}
	}
	
	public void timer(){
		if (gorodaRegistrationOpen && new Date().getTime()-gorodaLastAction>=GORODA_MAX_REG_TIME){
			if (gorodaPlayers.size()<2){
				sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(gorodaChannel, "Время регистрации истекло, но хотя бы 2 человека так и не зарегистрировалось, поэтому игра не состоится :-("));
				gorodaRegistrationOpen = false;
				return;
			}
			gorodaIsRun = true;
			gorodaRegistrationOpen = false;
			gorodaCurUser = rand.nextInt(gorodaPlayers.size());
			gorodaLoad();
			gorodaLastAction = new Date().getTime();
			String list = "";
			for (int i = 0; i < gorodaPlayers.size(); i++) {
				list += gorodaPlayers.get(i)+" ";
			}
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(gorodaChannel, "Итак, в города будут играть: " + list));
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(gorodaChannel, "Итак,"+gorodaPlayers.get(gorodaCurUser)+" - Вы начинаете! назовите город на букву "+last));
			gorodaIsWarning = false; 
		}else if(gorodaIsRun && new Date().getTime()-gorodaLastAction>=GORODA_MAX_ANS_TIME){
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(gorodaChannel, gorodaPlayers.get(gorodaCurUser)+", время на ответ истекло, и вы проиграли!"));
			gorodaPlayers.remove(gorodaCurUser);
			if (gorodaPlayers.size()==1){
				sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(gorodaChannel, gorodaPlayers.get(0)+" - вы выиграли"));
				gorodaIsRun = false;
				return;
			}
			gorodaCurUser = gorodaCurUser%gorodaPlayers.size();
			gorodaLastAction = new Date().getTime();
			gorodaIsWarning = false;
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(gorodaChannel, "Сейчас ход "+gorodaPlayers.get(gorodaCurUser)+". Вам надо назвать город на букву "+last));		
		}else if(gorodaIsRun && !gorodaIsWarning && new Date().getTime()-gorodaLastAction>=GORODA_MAX_ANS_TIME/2){
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(gorodaChannel, gorodaPlayers.get(gorodaCurUser)+", прошла половина времени на ответ!"));
			gorodaIsWarning = true;
		}
	}
	
	void goroda(String channel,String author,String msg){
		if (channel==null)return;
		System.err.println(msg);
		if(msg.length()>3 && msg.substring(0, 4).equalsIgnoreCase("хелп")){
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(author, "Команды игры города:"));
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(author, ru.svem.ircbot.MegaIrcBot.OPPREFIX+"города - запустить игру"));
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(author, ru.svem.ircbot.MegaIrcBot.OPPREFIX+"городарег - зарегистрироваться на игру"));
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(author, ru.svem.ircbot.MegaIrcBot.OPPREFIX+"городастопрег - закрыть регистрацию (может только тот, кто запустил игру)"));
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(author, ru.svem.ircbot.MegaIrcBot.OPPREFIX+"города ответ или ответ -  ответить"));
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(author, ru.svem.ircbot.MegaIrcBot.OPPREFIX+"городахелп - эта помощь"));
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(author, "ВОТ!"));
			return;
		} 
		if((gorodaIsRun || gorodaRegistrationOpen) && !channel.equalsIgnoreCase(gorodaChannel)){
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(channel, "Игра города уже идет на канале "+gorodaChannel));
			return;
		}
		if (!gorodaIsRun && !gorodaRegistrationOpen){
			if (!channel.contains("#")){
				sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(channel, "регистрацию на игру Города можно запустить только на канале!"));
				return;
			}
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(channel, "регистрация на игру ГОРОДА открыта наберите "+ru.svem.ircbot.MegaIrcBot.OPPREFIX+"городарег для регистрации на игру, у вас есть "+GORODA_MAX_REG_TIME/1000+" секунд для этого."));
			gorodaChannel = channel;
			gorodaLastAction = new Date().getTime();
			gorodaMain = author;
			gorodaPlayers = new Vector<String>();
			gorodaRegistrationOpen = true;
			
			for (int i = 0; i < channels.size(); i++) {
				if (!channels.get(i).equalsIgnoreCase(channel)){
					sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(channels.get(i),"на канале "+channel+" запущена игра Города"));
					try {
						Thread.sleep(250);
					}catch (InterruptedException e){}
				}
			}
			return;
		}
		if(msg.length()>2 && msg.substring(0, 3).equalsIgnoreCase("рег")){
			if (!gorodaRegistrationOpen){
				sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(channel, author + " регистрация закрыта!"));
				return;
			}
			for (int i = 0; i < gorodaPlayers.size(); i++) {
				if (gorodaPlayers.get(i).equalsIgnoreCase(author)){
					sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(channel, author + " вы уже зарегистрированы!"));
					return;
				}
			}
			gorodaPlayers.add(author);
			sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(channel, author + " вы зарегистрированы!"));
		}
		if (gorodaRegistrationOpen && author.equalsIgnoreCase(gorodaMain) && 
			msg.length()>6 && msg.substring(0, 7).equalsIgnoreCase("стопрег")){
			gorodaLastAction = 0;
		}else if (msg.length()>0 && msg.charAt(0)==' '){
			if(!author.equalsIgnoreCase(gorodaPlayers.get(gorodaCurUser))){
				System.err.println( "сейчас играет "+gorodaPlayers.get(gorodaCurUser)+", а не "+author);
				sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(channel, "сейчас играет "+gorodaPlayers.get(gorodaCurUser)));
				return;
			}
			msg  = msg.trim();			
			int res = motion(msg);
			System.err.println(msg+" "+res);
			if (res==GorodaPlugin.CITY_NOT_EXIST){
				sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(channel, msg + " - я не знаю такого города"));
				return;
			}else if(res==GorodaPlugin.CITY_IN_USE){
				sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(channel, msg + " - этот город уже был"));
				return;
			}else if(res==GorodaPlugin.CITY_NOT_VALID){
//				sout.println(channelMessage(channel, msg + " - этот город не начинается на букву "+(char)gorodaGame.last));
				return;
			}else if(res==GorodaPlugin.GAME_OVER){
//				sout.println(channelMessage(channel, author+ " - вы победили"));
//				return;				
			}else{
				gorodaCurUser = (gorodaCurUser+1)%gorodaPlayers.size();
				gorodaLastAction = new Date().getTime();
				gorodaIsWarning = false;
				sout.println(ru.svem.ircbot.MegaIrcBot.channelMessage(channel, "Сейчас ход "+gorodaPlayers.get(gorodaCurUser)+". Вам надо назвать город на букву "+last));
			}
		}
	}

	
	NavigableMap<String,Boolean> can;
	Random rand;
	{
		rand = new Random();
	}
	public char last;
	String gorodaLoad(){
		can = new TreeMap<String, Boolean>();
		BufferedReader fin = null;
		try {
			fin = new BufferedReader(new InputStreamReader(new FileInputStream("cites.list"),"utf8"));
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
			return "Не будем нихрена мы играть подробности у владельца бота";
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		try{
			String city;
			while ((city=fin.readLine())!=null){
				can.put(city.toLowerCase(), true);
			}
		}catch (Exception e) {}
		if (can.size()==0){
			System.err.println("City not found!");
			return "Не будем нихрена мы играть подробности у владельца бота";
		}
		Set<String> cs = can.descendingKeySet(); 
		while(true){
			char start = (char)('а'+rand.nextInt(33));
//			System.err.println(start);
			for (Iterator<String> i = cs.iterator(); i.hasNext();) {
				String e = i.next();
//				System.err.println(e);
				if (e.charAt(0)==start){
					last = start;
					return ""+start;
				}
			}
		}
		
	}
	
	int motion(String ans){
		ans = ans.toLowerCase();
		if (ans.charAt(0)!=last) return CITY_NOT_VALID;
		if (!can.containsKey(ans))return CITY_NOT_EXIST;
		if (!can.get(ans))return CITY_IN_USE;
		can.put(ans, false);
		Set<Map.Entry<String,Boolean>> es = can.entrySet();
		for (int i = ans.length()-1; i>0; i--) {
			char start = ans.charAt(i);			
			for (Iterator<Map.Entry<String,Boolean>> it = es.iterator(); it.hasNext();) {
				Map.Entry<String,Boolean> e = it.next();
				if (e.getKey().charAt(0)==start && e.getValue()){
					last = start;
					return start;
				}
			}
		}
		return GAME_OVER;
	}
	Vector<String> channels;
	PrintWriter sout;
	public String[] help(){
		String[] res = new String[1];
		res[0] = ru.svem.ircbot.MegaIrcBot.OPPREFIX+"города  -  игра Города, подробности "+ru.svem.ircbot.MegaIrcBot.OPPREFIX+"городахелп";
		return res;
	}
	public void init(PrintWriter sout, Vector<String> channels){
		this.channels = channels;
		this.sout = sout;
		
	}
}
