package ru.svem.ircbot.plugins;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Vector;

import ru.svem.ircbot.MegaIrcBot;
import ru.svem.mix.NoBlockBufferedReader;


public class MaximaPlugin extends ru.svem.ircbot.MegaIrcBotPlugin {
	public static final long DIE_WAIT = 10*60*1000;
	public String[] help(){
		String[] res = new String[2];
		res[0] = MegaIrcBot.OPPREFIX+"maxima - запускает максиму для вас(работает только в привате)";
		return res;
	}
	
	Map<String,Executable> per_user;
	Set<String> allow_users;  
	public void message(String channel, String author, String msg) {
		if(!allow_users.contains(author)){
			System.err.println(author+" can't use maxima plugin");
			return;
		}
		if (channel!=null)return;
		if(msg.length()>6 && msg.substring(0,7).equalsIgnoreCase(ru.svem.ircbot.MegaIrcBot.OPPREFIX+"maxima") ){
			 if (!per_user.containsKey(author)){
				 Executable mx = new Executable("maxima");
				 per_user.put(author, mx);
				 return;
			 }else{
					sout.println(MegaIrcBot.channelMessage(author,"Надо вначале выключить предыдущую программу"));
			 }
		}else if(msg.length()>4 && msg.substring(0,5).equalsIgnoreCase(ru.svem.ircbot.MegaIrcBot.OPPREFIX+"exit") ){
			 if (per_user.containsKey(author)){
				 Executable ex = per_user.get(author);
				 ex.kill();
			 }
		}
		if (!per_user.containsKey(author)){
			sout.println(MegaIrcBot.channelMessage(author,"Надо вначале запустить программу"));
			return;
		}
		per_user.get(author).write(msg);
	}

	public void timer() {
		for (Map.Entry<String, Executable> mx : per_user.entrySet()) {
			String author = mx.getKey();
			Executable ex = mx.getValue();
			if (ex.tryKill()){
				per_user.remove(author);
				sout.println(MegaIrcBot.channelMessage(author,"--program terminate--"));
			}
			String s;
			while ((s = ex.in.readLine())!=null){
				sout.println(MegaIrcBot.channelMessage(author,s));
			}
		}
	}
	
	Vector<String> channels;
	PrintWriter sout;
	
	public void init(PrintWriter sout, Vector<String> channels){
		this.channels = channels;
		this.sout = sout;		
		per_user = new TreeMap<String, Executable>();
		allow_users = new TreeSet<String>();
		try {
			BufferedReader br = new BufferedReader(new FileReader("maxima.allow"));
			while(true){
				try {
					String s = br.readLine();
					if (s==null)break;
					if (s.contains("#"))continue;
					allow_users.add(s);
				} catch (IOException e) {					
				}
			}
		} catch (FileNotFoundException e) {
			System.err.println("");
			e.printStackTrace();
		}

	}
}

class Executable{
	Process pr;
	public NoBlockBufferedReader in;
	PrintWriter out;
	long last_access;
	public Executable(String command) {	
		try {
			pr = Runtime.getRuntime().exec(command);
			in = new NoBlockBufferedReader(pr.getInputStream());
			out = new PrintWriter(pr.getOutputStream());
			last_access = System.currentTimeMillis();
		} catch (IOException e) {
			e.printStackTrace();
			last_access = -100000000;
		}
	}
	public void write(String s){
		last_access = System.currentTimeMillis();
		out.println(s);
		out.flush();
	}
	
	public boolean tryKill(){
		try{
			pr.exitValue();
			in.close();
			return true;
		}catch (IllegalThreadStateException e) {
			if (System.currentTimeMillis()-last_access > MaximaPlugin.DIE_WAIT){
				pr.destroy();
				in.close();
				return true;
			}
		}
		return false;
	}
	public void kill(){
		pr.destroy();
		in.close();
	}
}