package ru.svem.mix;

import java.io.BufferedReader;
import java.io.Closeable;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.LinkedList;

public class NoBlockBufferedReader implements Closeable{
	BufferedReader in;
	LinkedList<String> buffer;
	NoBlockBufferedReaderThread nbbrt;
	
	public NoBlockBufferedReader(BufferedReader in) {
		this.in = in;
		buffer = new LinkedList<String>();
		nbbrt = new NoBlockBufferedReaderThread(this.in,buffer);
		nbbrt.start();
	}
	public NoBlockBufferedReader(InputStream in) {
		this.in = new BufferedReader(new InputStreamReader(in));
		buffer = new LinkedList<String>();
		nbbrt = new NoBlockBufferedReaderThread(this.in,buffer);
		nbbrt.start();
	}
	
	public String readLine(){
		synchronized (buffer) {
			if (buffer.size()==0){
				return null;
			}
			return buffer.removeFirst();
		}
	}
	public void close(){
		nbbrt.need_stop = true;
	}
	class NoBlockBufferedReaderThread extends Thread{
		BufferedReader in;
		LinkedList<String> buffer;
		public boolean need_stop;
		public NoBlockBufferedReaderThread(BufferedReader in,LinkedList<String> buffer){
			this.in = in;
			this.buffer = buffer;
		}
		
		public void run(){
			need_stop = false;
			while (!need_stop){
				String s;
				try {
					s = in.readLine();
				} catch (IOException e) {
					try {
						Thread.sleep(100);
					} catch (InterruptedException e1) {
						e1.printStackTrace();
					}
					continue;
				}
				
				if (s!=null){
					synchronized (buffer) {
						buffer.addLast(s);
					}
				}
			}

		}
	}
}
